#include"RACE_DataBlock.h"
#include<stdlib.h>

void RACE::DataBlockFactory::informduplicate(RACE::DataBlock *)
{
}

void RACE::DataBlockFactory::informrelease(RACE::DataBlock *)
{
}

RACE::DataBlock *RACE::DataBlockFactory::create(DataBlockFactory* dbf,char *buffer,size_t size,bool withcontent)
{
  RACE::DataBlock *ret;
  ret= new RACE::DataBlock(this,buffer,size,withcontent);
  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);
  return ret;
}

void RACE::DataBlockFactory::destroy(RACE::DataBlock *schrott)
{
  delete schrott;
}

static RACE::StupidMallocDataBlockFactory smdbf;
RACE::DataBlock* RACE::DataBlock::alloc(size_t size) throw (NoMoreDynamicMemory)
{
  return smdbf.generate(size);
}

RACE::DataBlock* RACE::DataBlock::clone() throw (NoMoreDynamicMemory)
{
  RACE::DataBlock* ret=smdbf.generate(length());
  ret->grow(length());
  memcpy(ret->basis,begin(),length());
  return ret;
}

RACE::DataBlock::~DataBlock()
{
}

RACE::DataBlock *RACE::DataBlock::duplicate()
{
  ACE_GUARD_RETURN(ACE_Thread_Mutex, ace_mon, this->refcountmutex_,0);
  reference_count_++;
  dbf_->informduplicate(this);
  return this;
}

void RACE::DataBlock::release()
{
  refcountmutex_.acquire();
  reference_count_--;
  if(reference_count_ == 0)
  {
    refcountmutex_.release();
    dbf_->recycle(this); // recycle calls implizitly informrelease
  }
  else
  {
    dbf_->informrelease(this);
    refcountmutex_.release();
  }
}

void RACE::DataBlock::grow(size_t n) throw (BufferOverflow)
{
  if(n>freespace()) throw BufferOverflow(freespace(),n);
  cur_size_+=n;
}


RACE::DataBlock *RACE::StupidMallocDataBlockFactory::generate(size_t size) throw (NoMoreDynamicMemory)
{
  RACE::DataBlock* ret; 

  if(size>0)
  {
    ret=create(this,(char *)malloc(size),size,false);
    RACE_MEMORY_FAIL(ret->begin()==NULL,__FILE__,__LINE__,__FUNCTION__);
  }
  else
  {
    ret=create(this,NULL,0);
  }
 
  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);
  return ret;
}

void RACE::StupidMallocDataBlockFactory::recycle(RACE::DataBlock *schrott)
{
  free((void *)(schrott->begin()));
  destroy(schrott);
}


