#ifndef RACE_LOGGERQLS_H
#define RACE_LOGGERQLS_H
#include<ace/OS.h>
#include"RACE_QueueLevelStrat.h"
#include <utility/envdebug.h>
//##Documentation
//## Special Queue Level Strategy for the Logger
//## In the view of the Loggerthread the queue never gets full
//## To avoid Deadlocks
//## The decision throwing away dispensible Dumpables is also made here
//## The Queue and the Logger itself see this
class RACE_LoggerQLS : public RACE_QueueLevelStrategy
{
 public:
  RACE_LoggerQLS(const char *queuename);
  virtual const char *GetQueueName();
  virtual bool is_full();
  virtual bool can_enqueue();
  virtual bool is_critical_watermark_reached();
  void SetLoggerThreadId(const ACE_thread_t &ltid) { m_loggerThreadId=ltid; }
  bool IsCallerLoggerThread() { return ACE_OS::thr_self()==m_loggerThreadId; }
  virtual ACE_Time_Value *GetCurrentEnqueueTimeout();
 protected:
  static envdebug *s_debug;
 private:
  const char *m_queuename;
  size_t m_MaxLengthSum;
  size_t m_DiscardDispensableLengthSum;
  ACE_thread_t m_loggerThreadId;
  ACE_Time_Value m_relativeTimeout;
  ACE_Time_Value m_currentAbsolutTimeout;

};
#endif

