#include"RACE_LoggerStrategy.h"
#include<stdlib.h>

RACE_LoggerStrategy::RACE_LoggerStrategy(const char *queuename):RACE_LoggerQLS(queuename),periode_in_s_(0)
{
  const char *envstr;
  if((envstr=getenv("RACE_PERIODIC_TIME_IN_S"))!=NULL)
  {
    periode_in_s_=atol(envstr);
  }
}

ACE_Time_Value *RACE_LoggerStrategy::GetCurrentDequeueTimeout()
{
  if(periode_in_s_>0)
  {
    ACE_Time_Value relative(periode_in_s_,0);
    m_currentAbsolutTimeout=ACE_OS::gettimeofday()+relative;
    return &m_currentAbsolutTimeout;
  }
  else
  {
    return 0;
  }
}

long RACE_LoggerStrategy::periode_in_s()
{
  return periode_in_s_;
}

void RACE_LoggerStrategy::periodic_callback(time_t now)
{
  s_debug->print("RACE_LoggerStrategy::periodic_callback(%ld)",now);
}

