#include <utility/errorhandling.h>
#include"RACE_Message_Block.h"
#include<string.h>
#include<stdlib.h>

//##ModelId=3F72A5CA030C
int RACE_Message_Block::copy(const char *buf, size_t n) throw (BufferOverflow)
{
  memcpy(wr_ptr(n),buf,n);
  return n;
}

//##ModelId=3F72A5CD0269
RACE_Message_Block *RACE_Message_Block::duplicate(void) const
{
  RACE_Message_Block *ret = CloneManagementData();
  ret->first_=first_;
  ret->db=db;
  ret->reset_current();
  for(RACE::DataBlock *cur=first_;cur!=NULL;cur=cur->next)
  {
    cur->duplicate();
  }
  return ret;
}

//##ModelId=3F72A5CD0326
RACE_Message_Block *RACE_Message_Block::clone(void) const
{
  RACE_Message_Block *ret = CloneManagementData();
  ret->block_size_=block_size_;
  ret->first_=NULL;
  RACE::DataBlock **cur_insert=&(ret->first_);
  for(RACE::DataBlock *cur=first_;cur!=NULL;cur=cur->next)
  {
    ret->db=*cur_insert = cur->clone();
    ret->reset_current();
    cur_insert=&((*cur_insert)->next);
  }
  return ret;
}

//##ModelId=3F72A5CE035D
RACE_Message_Block *RACE_Message_Block::CloneManagementData() const
{
  RACE_Message_Block *ret;
  ret = new RACE_Message_Block();
  RACE_COND_FAIL(ret==NULL,"%s%d:RACE_Message_Block::CloneManagementData(): No More Memory",
            __FILE__,__LINE__);
  return ret;
}

//##ModelId=3F72A5C902FE
RACE_Message_Block::RACE_Message_Block(size_t len):block_size_(len)
{
  first_=db=RACE::DataBlock::alloc(len);
  reset();
  next_=0;
  prev_=0;
}

RACE_Message_Block::RACE_Message_Block(RACE::DataBlock *edb,bool frag)
  :db(edb),first_(edb),
   block_size_(edb->size()),
   rd_ptr_(0),
   wr_ptr_(edb->length()),
   next_(0),prev_(0)
{
  first_=db=edb;
  if(frag);
}
//##ModelId=3F72A5C903DE
RACE_Message_Block::~RACE_Message_Block()
{
  RACE::DataBlock *temp=NULL;
  RACE::DataBlock *cur = first_;
  while(cur!=NULL)
  {
    temp=cur;
    cur=cur->next;
    temp->release();
  }
}

char *RACE_Message_Block::wrptr_align(short potenz2)
{
  char *old=wr_ptr();
  long a=1<<potenz2;
  long mask=a-1;
  try
  {
    RACE_COND_FAIL(sizeof(char *)!=sizeof(long),"%s:%d:sizeof(char *)!=sizeof(long)",__FILE__,__LINE__);
    wr_ptr((char *)((long(old)+mask)&(~mask)));
    memset(old,'\0',wr_ptr()-old);
  }
  catch(BufferOverflow& ex)
  {
    wr_ptr(old);
  }
  return wr_ptr();
}

//##ModelId=3F72A5CD013D
void RACE_Message_Block::expand()
{
  db->next = RACE::DataBlock::alloc(block_size_);
  db=db->next;
  reset();
}

void RACE_Message_Block::addblock(RACE::DataBlock *block)
{
  db->next=block;
  db=db->next;
  reset();
}

//##ModelId=3F72A5CC03B3
size_t RACE_Message_Block::total_length(void) const
{
  size_t ret=0;
  for(RACE::DataBlock *cur=first_;cur!=NULL;cur=cur->next)
  {
    ret += cur->length();
  }
  return ret;
}

//##ModelId=3F72A5CD0083
size_t RACE_Message_Block::total_size(void) const
{
  size_t ret=0;
  for(RACE::DataBlock *cur=first_;cur!=NULL;cur=cur->next)
  {
    ret += cur->size();
  }
  return ret;
}




