#include"RACE_Thread.h"

envdebug *RACE_Thread::debug = new envdebug("RACE_Thread");

RACE_Thread::~RACE_Thread()
{
  debug->print("RACE_Thread::~RACE_Thread()");
}

void RACE_Thread::start()
{
  refcount_++;
  thread_group_id = ACE_Thread_Manager::instance()->spawn(proc_to_run,this);
}

void *RACE_Thread::proc_to_run(void *myself)
{
  RACE_Thread *w = (RACE_Thread *)myself;
  w->run();
  w->release();
  return NULL;
}


void RACE_Thread::release()
{
  bool instance_obsolete = false;
  {
    ACE_GUARD(ACE_Thread_Mutex,guard,refcount_mutex_);
    debug->print("RACE_Thread::release()");
    refcount_--;
    if(refcount_==0)
    {
      instance_obsolete = true;
    }
  }
  if(instance_obsolete)
  {
    delete this;
  }
}

int RACE_Thread::number_of_refs()
{
  ACE_GUARD_RETURN(ACE_Thread_Mutex,guard,refcount_mutex_,-1);
  return refcount_;
}

RACE_Thread *RACE_Thread::duplicate()
{
  ACE_GUARD_RETURN(ACE_Thread_Mutex,guard,refcount_mutex_,NULL);
  debug->print("RACE_Thread::duplicate");
  refcount_++;
  return this;
}

