#include"RACE_LogfileOffset.h"
#include"RACE_Accumulator.h"
#include<string.h>
#include<iostream>
using namespace std;

//##ModelId=3F72A5C5019F
//##Documentation
//##  A Dumpable for testing

class RACE_MyDumpable : public RACE_Dumpable
{
    //##ModelId=3F72A5C802A2
  char pat_;
    //##ModelId=3F72A5C802A4
  RACE_MyDumpable(char pat):pat_(pat) {} // For Cloning
public:
    //##ModelId=3F72A5C802A8
  RACE_MyDumpable(size_t s,char pat):RACE_Dumpable(s),pat_(pat)
  {
    memset(wr_ptr(),pat,s);
    wr_ptr(s);
  }
    //##ModelId=3F72A5C802AB
  virtual void InformOffset(RACE_LogfileOffset offset);
protected:
    //##ModelId=3F72A5C802AF
  virtual RACE_Message_Block *CloneManagementData() const;
};

//##ModelId=3F72A5C802AB
void RACE_MyDumpable::InformOffset(RACE_LogfileOffset offset)
{
  cerr << "Written Pattern '" << pat_ << "' at offset "
       << offset.part << ':' << offset.offset << endl;
}

//##ModelId=3F72A5C802AF
RACE_Message_Block *RACE_MyDumpable::CloneManagementData() const
{
  RACE_MyDumpable* ret = new RACE_MyDumpable(pat_);
  return ret;
}

RACE_Dumpable *genentry(size_t s,char pat)
{
  std::cerr << "genentry(" << s << "," << pat << ");" << std::endl;
  return new RACE_MyDumpable(s,pat);
}

RACE_Dumpable *genfragmented(size_t s,char pat1,char pat2)
{
  std::cerr << "genfragmented(" << s << "," << pat1 << "," << pat2 << ");"
            << std::endl;
  RACE_Dumpable *f = new RACE_MyDumpable(s,pat1);
  f->expand();
  memset(f->wr_ptr(),pat2,s);
  f->wr_ptr(s);
  return f;
}

//##ModelId=3F72A5C501A8
//##Documentation
//##  Simulates a Writer

class RACE_TestWriter : public RACE_WriterInterface
{
public:
  virtual void Open();
  virtual void Close();
    //##ModelId=3F72A5C802BB
  virtual int WriteV(const  struct  iovec*  v,  int count);
    //##ModelId=3F72A5C802C0
  virtual long PartNo();
  virtual void SwitchPart();
};

void RACE_TestWriter::Open()  {}
void RACE_TestWriter::Close() {}

//##ModelId=3F72A5C802BB
int RACE_TestWriter::WriteV(const  struct  iovec*  v,  int count)
{
  int i;
  std::cerr << "count=" << count << std::endl;
  size_t sum=0;
  for(i=0;i<count;i++)
  {
    char *str = (char *)(v[i].iov_base);
    std::cerr << v[i].iov_len << " " << str[0] << "  " ;
    sum+=v[i].iov_len;
  }
  std::cerr << "\nsum=" << sum << std::endl;
  return sum;
}

//##ModelId=3F72A5C802C0
long RACE_TestWriter::PartNo()
{
  return 0;
}

void RACE_TestWriter::SwitchPart()
{
}

int main(int,char**)
{
  RACE_TestWriter log;
  RACE_Accumulator acc(&log);
  acc.Add(genentry(4096,'0'));
  acc.Add(genentry(400,'1'));
  acc.Add(genentry(1024,'2'));
  acc.Add(genentry(2048,'3'));
  acc.Add(genentry(1024,'4'));
  acc.Add(genentry(8192,'5'));
  acc.Add(genentry(80,'6'));
  acc.Flush();
  std::cerr << "too many (30>20) litte blocks, need flushing ..." << std::endl;
  for(int i=0;i<30;i++)
  {
    acc.Add(genentry(5,'l'));
  }
  acc.Flush();
  std::cerr << "Test with a fragmented Dumpable " << endl;
  acc.Add(genfragmented(1024,'a','b'));
  acc.Add(genentry(10,'-'));
  acc.Add(genfragmented(4096,'c','d'));
  acc.Flush();
  std::cerr << "The last 'b' and 'd'-Pattern mustn't be notified!" << std::endl;
}

