#include<iostream>
#include"RACE_Logger.h"
#include"RACE_Logfile.h"

class AlwaysSwitch : public RACE_LogSwitchingStrategy
{
public: 
    AlwaysSwitch(RACE_LogSwitcher *ls=0):RACE_LogSwitchingStrategy(ls) {}
    virtual void InfoCurrentOffset(off_t offset);
    virtual void InfoSnapshotWritten();
};

void AlwaysSwitch::InfoCurrentOffset(off_t offset)
{
    m_CurrentOffset = offset;
    mp_LogSwitcher->SwitchLog();
}

void AlwaysSwitch::InfoSnapshotWritten()
{
}

class CTestDumpable : public RACE_Dumpable
{
  char pat_;
  CTestDumpable(char pat):pat_(pat) {} // For Cloning
public:
  CTestDumpable(size_t s,char pat):RACE_Dumpable(s),pat_(pat)
  {
    memset(wr_ptr(),pat,s);
    wr_ptr(s);
  }
  virtual RACE_Message_Block *CloneManagementData() const;
  virtual void InformOffset(RACE_LogfileOffset offset);
};

void CTestDumpable::InformOffset(RACE_LogfileOffset offset)
{
  std::cerr << "Written Pattern '" << pat_ << "' with length=" << total_length()
       << "\tat offset " << offset.part << ':' << offset.offset << std::endl;
}

RACE_Dumpable *genentry(size_t s,char pat)
{
  return new CTestDumpable(s,pat);
}

RACE_Dumpable *genfragmented(size_t s,int count,char pat1,char pat2)
{
  int i;
  RACE_Dumpable *f = new CTestDumpable(s,pat1);
  for(i=0;i<count-1;i++)
  {
    f->expand();
    memset(f->wr_ptr(),pat2,s);
    f->wr_ptr(s);
  }
  return f;
}

RACE_Message_Block *CTestDumpable::CloneManagementData() const
{
  CTestDumpable* ret = new CTestDumpable(pat_);
  return ret;
}

int main(int,char **argv)
{
  RACE_Logfile logfile;
  RACE_Dumpable *d;
  char **arg;
  int c=0;
  char pat;
  logfile.Open("switchingtest");
  logfile.SetFilenameBody("switchingtest");
  RACE_LoggerStrategy loggerstrat("switchingtest");
  AlwaysSwitch logswitching;
  RACE_Logger *logger=new RACE_Logger(&logfile,&loggerstrat,&logswitching);
  logger->activate();
  arg=argv+1;
  while(*arg!=NULL)
  {
      long l = strtol(*arg,NULL,10);
      pat = 'A' + (c%24);
      std::cerr << "Generating Dumpable " << pat << " of site " << l << std::endl;
      d = genentry(l,pat);
      logger->Log(d);
      arg++;
      c++;
  }
  logger->Cancel();
  logger->wait();
  logger->Release();
  
  std::cerr << "done" << std::endl;
  return 0;
}

