#ifndef RACE_DEPOSITORY_H
#define RACE_DEPOSITORY_H
#include"RACE_LogfileBase.h"
#include"RACE_DepositoryNames.h"

//##ModelId=3F72AF4203C1
//##Documentation
//## A Depository is an another kind of an RACE_Interface
//## Instead of groeing indefinitly like an logfile,
//## a depository is compressed, the old instances are thown away.
class RACE_Depository : public RACE_LogfileBase, public RACE_DepositoryNames
{
public:
    //##ModelId=3F72AF43004B
  RACE_Depository();
  virtual const char *GetBasename() const;
    //##ModelId=3F72AF43004D
    //##Documentation
    //## Opens the Depository for entity_name
    //## returns true if recovery has to be done
  virtual void Open(const char *entity_name);
  virtual void Open();
  virtual void SwitchPart();
  //##Documentation
  //## returns true if recovery has to be done
  bool WasRecovered() { return wasrecovered_; }
    //##ModelId=3F72AF43004F
  virtual void Close();
    //##ModelId=3F72AF430051
  //##Documentation
  //## RACE_WriterInterface-Interface from Accumulator
  virtual int WriteV(const  struct  iovec  *  vector,  int count);
    //##ModelId=3F72AF430056
  //##Documentation
  //## RACE_WriterInterface-Interface from Accumulator
  //## We have always only one part
  virtual long PartNo();
 
  //##ModelId=3FB3B45600FC
  //##Documentation
  //## Saves the Depository.dp in Depository.old.dp and the over files
  //## in the same way
  void MoveAway();

    //##ModelId=3FCF3A2D0169
  //##Documentation
  //## Renames the former new file to the second File
  //## The Logfilereader reads it after the old
  //## Returns true it the Second file exists. It looks bad
  bool SaveUncompleteNew();

  //##Documentation
  //## Checks if a new empty Depository exists. 
  //## If so, remove it
  bool  CheckAndRemoveZeroLengthNew(); 
    //##ModelId=3FB3B456010B
  //##Documentation
  //## deletes the saved Depository
  void RemoveOld();

    //##ModelId=3FCF3A2D0178
  //##Documentation
  //## deletes the Depository
  void Remove();

    //##ModelId=3FB3B456010C
  //##Documentation
  //## reopens the File for Logfileswitching
  void Reopen();

private:
  //##ModelId=3F72AF430041
  int m_fd;
  bool wasrecovered_;
};
#endif
