#include "RACE_DepositoryNames.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <utility/errorhandling.h>

const char *RACE_DepositoryNames::ms_persistentpath="./";

void RACE_DepositoryNames::init(const char *persistentpath)
{
  ms_persistentpath=persistentpath;
}

RACE_DepositoryNames::RACE_DepositoryNames()
{
  m_basefilename[0]='\0';
  m_filename[0]='\0';
  m_indexfilename[0]='\0';
  m_oldfilename[0]='\0';
  m_oldindexname[0]='\0';
  m_uncompletenewfilename[0]='\0';
}

RACE_DepositoryNames::RACE_DepositoryNames(const char *entity_name)
{
  initialize(entity_name);
}

void RACE_DepositoryNames::initialize(const char *entity_name)
{
  snprintf(m_basefilename,256,"%s/%s",ms_persistentpath,entity_name);
  snprintf(m_filename,256,"%s.dp",m_basefilename);
  snprintf(m_oldfilename,256,"%s_1.dp",m_basefilename);
  snprintf(m_indexfilename,256,"%s.idx",m_basefilename);
  snprintf(m_oldindexname,256,"%s_1.idx",m_basefilename);
  snprintf(m_uncompletenewfilename,256,"%s_2.dp",m_basefilename);
}

bool RACE_DepositoryNames::ExistsOld()
{
  struct stat oldstatbuf;
  int r;
  r=::stat(GetOldFilename(),&oldstatbuf);
  if(r<0)
  {
    if(errno==ENOENT) return false;
    output::error("RACE_Depository::CheckUncompleteNew:stat(%s):%s",GetOldFilename(),
		 strerror(errno));
    return false;
  }
  return true;
}


