#include<iostream>
#include<utility/errorhandling.h>
#include"RACE_LogIndexPositioner.h"
#include"RACE_ReaderDriver.h"

void RACE_ReaderDriver::readuntilend()
{
  RACE::DataBlock *current;
  RACE_Dumpable *dumpable;
  bool fragmented;
  RACE_LogfileOffset currentoffset;
  int retry=0;
  do
  {
    try
    {
      while((current=reader_.Read(fragmented,currentoffset))!=NULL)
      {
	dumpable=interp_->interpret(current,fragmented,currentoffset);
	dumpable->CallVisitor(semantic_);
	dumpable->release();
      }
    }
    catch(RACE::ReadError& ex)
    {
	std::cerr << "ReadError: " << ex.what() << std::endl;
    }
  } while(retry>0);
  reader_.Close();
}

void RACE_ReaderDriver::readsnapshot(RACE_LogfileOffset wantedoffset)
{
  RACE::DataBlock *current;
  RACE_Dumpable *dumpable;
  bool fragmented;

  try
  {
    RACE_LogfileOffset lo;
    if((current = reader_.ReadAt(wantedoffset,fragmented,lo))!=NULL)
    {
      dumpable=interp_->interpret(current,fragmented,lo);
      dumpable->CallVisitor(snapshotsemantic_);
      dumpable->release();
    }
    else
    {
      std::cerr << "Position not found " << std::endl;
    }
  }
  catch(RACE::ReadError& ex)
  {
    std::cerr << ex.what() << std::endl;
  }
}

void RACE_ReaderDriver::readsnapshotattime(const char *timestr)
{
  RACE_LogIndexPositioner positioner(reader_.GetIndexFilename());
  RACE_LogfileOffset wantedoffset;
  try
  {
    if(!positioner.IsEmpty())
    { 
      time_t time = positioner.StrToTime(timestr);
      wantedoffset = positioner.Get(time);
      readsnapshot(wantedoffset);
    }
  }
  catch(RACE_LogIndexPositioner::RangeError& ex)
  {
    std::cerr << ex.What() << std::endl;
  }
}

void RACE_ReaderDriver::readlastsnapshot()
{
  RACE_LogIndexPositioner positioner(reader_.GetIndexFilename());
  RACE_LogfileOffset wantedoffset;
  try
  {
    if(!positioner.IsEmpty())
    {  
      wantedoffset = positioner.GetLastOffset();
      readsnapshot(wantedoffset);
    }
  }
  catch(RACE_LogIndexPositioner::RangeError& ex)
  {
    std::cerr << ex.What() << std::endl;
  }
}
