#ifndef RACE_WAITINGFULLBUFFERHANDLING_H
#define RACE_WAITINGFULLVUFFERHANDLING_H
#include<RACE_ReadBuffer.h>

namespace RACE
{
  //##Documentation
  //## FullBufferHandlingStrategy for the case when the dumpables are
  //## consumed and released in an extra thread
  class WaitingFullBufferHandling: public FullBufferHandlingStrategy
  {
  public:
    WaitingFullBufferHandling(ReadBuffer *rb=0)
      :FullBufferHandlingStrategy(rb),
       bufferfull_(mutex_),
      firstfree_(0),freepages_(0) {}
    virtual Index_t notifyBufferIsFull() throw (BufferFull);
    virtual void notifyPageGetFree(Index_t freepage);
  private:
    ACE_Thread_Mutex mutex_;
    ACE_Thread_Condition<ACE_Thread_Mutex> bufferfull_;
    Index_t firstfree_;
    int freepages_;
  };
};
#endif
