#include<iostream>
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/mman.h>
#include<fcntl.h>
#include<string.h>
#include<time.h>
#include<utility/errorhandling.h>
#include<error.h>
#include"LSFullPageDumpable.h"
#include"LSDiffPageDumpable.h"
#include"LSDReconstructSemantik.h"
#include"LStools.h"

const char * LSDReconstructSemantik::name()
{
  return "LSDReconstructSemantik";
}

LSDReconstructSemantik::LSDReconstructSemantik(const char *name,time_t until)
{
  char filename[128];
  long noofpages=1<<4;
  long len=noofpages<<12;
  name_=name;
  until=until_;
  struct tm *tmi=localtime(&until);
  snprintf(filename,128,"%s-%d%.2d%.2d-%.2d:%.2d:%.2d.ls",name,
	   (tmi->tm_year+1900),(tmi->tm_mon+1),tmi->tm_mday,
	   tmi->tm_hour,tmi->tm_min,tmi->tm_sec
	   );
  fd_=::open(filename,O_RDWR|O_CREAT,0666);
  RACE_COND_FAIL(fd_==-1,"open(%s) failed\n",filename);
  createzeroedfile(filename,fd_,noofpages);
  recseg.init((char *)::mmap(NULL,len,PROT_READ|PROT_WRITE,MAP_SHARED,fd_,0),len);
  RACE_COND_FAIL(recseg.begin()==NULL,"mmap failed");
}

LSDReconstructSemantik::~LSDReconstructSemantik()
{
  ::munmap((void *)(recseg.begin()),recseg.size());
  ::close(fd_);
}

void LSDReconstructSemantik::LogSegmentFullPageDumpable(LSFullPageDumpable *lsd)
{
  std::cerr << "LSFullPageDumpable at " << lsd->GetOffset().part << ':'
	    <<  lsd->GetOffset().offset << " :"
	    << "Page " << lsd->pageno() << std::endl;
  memcpy(recseg.pageno2addr(lsd->pageno()),lsd->pagebegin(),lsd->pagelength());
}

void LSDReconstructSemantik::LogSegmentDiffPageDumpable(LSDiffPageDumpable *lsd)
{
  std::cerr << "LSDiffPageDumpable at " << lsd->GetOffset().part << ':'
	    <<  lsd->GetOffset().offset << " :"
	    << "Page " << lsd->pageno() << std::endl;
  lsd->applydiff(recseg.pageno2addr(lsd->pageno()));
}
