#include"LSDiffPageDumpable.h"

LSDiffPageDumpable::LSDiffPageDumpable(RACE::DataBlock *header,RAMS::Mseg *page,RAMS::Mseg *oldcontent):LSDumpable(header)
{
  calculatediff(pageheader(),page,oldcontent);
}

void LSDiffPageDumpable::calculatediff(LSlayout::logpageheader *header,RAMS::Mseg *page,RAMS::Mseg *oldcontent)
{
  typedef unsigned char octet_t;
  off_t off=0;
  octet_t *p1=(octet_t *)(page->begin());
  octet_t *p2=(octet_t *)(oldcontent->begin());
  size_t pagesize=page->size();
  
  RACE::DataBlock *erg=RACE::DataBlock::alloc(pagesize);
  addblock(erg);
  while(size_t(off)<pagesize && (*p1 ^ *p2)==0)
  {
    off++;p1++;p2++;
  }
  header->offset_in_page=off;
  off_t boff=pagesize;
  octet_t *p1e=(octet_t *)(page->end())-1;
  octet_t *p2e=(octet_t *)(oldcontent->end())-1;
  while(boff>0 && (*p1e ^ *p2e)==0)
  {
    boff--;p1e--;p2e--;
  }
  while(off<boff)
  {
    *(wr_ptr(1))=(*p1 ^ *p2);
    off++;p1++;p2++;
  }
  header->type=LSlayout::diff;
  header->len_of_page=off-header->offset_in_page;
  header->len=sizeof(LSlayout::logpageheader)+header->len_of_page;
}

void LSDiffPageDumpable::applydiff(void *pageaddress)
{
    octet_t *pd=diffstart();
    octet_t *pde=diffstart()+difflen();
    octet_t *ps=(octet_t *)pageaddress+getOffsetInPage();
    while(pd<pde) 
    {
	*ps ^= *pd;
	ps++;pd++;
    }
}

void LSDiffPageDumpable::CallVisitor(RACE::DumpableVisitor *visitor)
{
  LSDSemantik *lsds = dynamic_cast<LSDSemantik *>(visitor);
  if(lsds!=NULL)
  {
    lsds->LogSegmentDiffPageDumpable(this);
  }
}
