#ifndef LSDIFFPAGEDUMPABLE_H
#define LSDIFFPAGEDUMPABLE_H
#include"LSDumpable.h"

class LSDiffPageDumpable : public LSDumpable
{
public:
  //##Documentation
  //## Constructor for diff pages
  LSDiffPageDumpable(RACE::DataBlock *header,RAMS::Mseg *page,RAMS::Mseg *oldcontent);

  //##Documentation
  //## Constructor for Interpreters
  LSDiffPageDumpable(RACE::DataBlock *db,RACE_LogfileOffset lo):
    LSDumpable(db,lo) {}

  
  //##Documentation
  //## calculate xor diff from page
  void calculatediff(LSlayout::logpageheader *,RAMS::Mseg *page,RAMS::Mseg *oldcontent);
  
  //##Documentation
  //## apply diff on a page
  void applydiff(void *pageaddress);
  virtual void CallVisitor(RACE::DumpableVisitor *visitor);
protected:
  off_t getOffsetInPage() { return pageheader()->offset_in_page; }
  octet_t *diffstart() { return (octet_t *)(pageheader()->page); }
  size_t difflen() { return pageheader()->len_of_page; }
};

#endif 
