#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<unistd.h>
#include<utility/errorhandling.h>

#ifndef _POSIX_MAPPED_FILES
#error "Missing _POSIX_MAPPED_FILES : Implementation only for standard os ! "
#endif

void createzeroedfile(const char *filename,int fd,long noofpages) throw (Systemerror)
{
  char *rpage;
  int f0=::open("/dev/zero",O_RDONLY);
  if(f0<0) throw Systemerror(errno,"open"," open(%s): %m","/dev/zero");
  rpage=(char *)::mmap(NULL,4096,PROT_READ,MAP_PRIVATE,f0,0);
  if(rpage==(char *)MAP_FAILED) throw Systemerror(errno,"mmap"," mmap(%s): %m", "/dev/zero");
  for(int i=0;i<noofpages;i++)
  {
    errno=0;
    size_t nw=::write(fd,rpage,4096);
    if(nw<4096) throw Systemerror(errno,"write","write(%s): written<4096",filename);
  }
  ::munmap(rpage,4096);
  ::close(f0);
}
