#include<iostream>
using namespace std;
#include<stdlib.h>
#include"shadowsegment.h"

#include<signal.h>
#include<stdio.h>

static void sigbus(int sig,siginfo_t *siginfo, void *unkown)
{
  fprintf(stderr,"SIGBUS catched:\n");
  char *p = (char *)((long)(siginfo->si_addr)&~(PAGESIZE-1)); 
  fprintf(stderr,"SIGBUS at ptr=%p page=%p ",siginfo->si_addr,p);
  switch(siginfo->si_code)
  {
  case BUS_ADRALN: fputs("invalid address alignment\n",stderr);
                   exit(1);
		   break;
  case BUS_ADRERR: fputs("non-existant physical address\n",stderr);	   
                   exit(1);
		   break;
  case BUS_OBJERR: fputs("object specific hardware error\n",stderr);
                   exit(1);
                   break;
  default:
    fprintf(stderr,"si_code=%d\n",siginfo->si_code);
    exit(1);
  }
}

int main(int argc,char **argv)
{
  ShadowSegment seg;
  int rollback=0;
  int crash=0;
  if(argc>1 && strcmp(argv[1],"-rollback")==0) rollback=1;
  if(argc>1 && strcmp(argv[1],"-crash")==0) crash=1;

  struct sigaction sa;
  sa.sa_flags = SA_SIGINFO|SA_RESTART;
  sigemptyset(&(sa.sa_mask));
  sa.sa_sigaction = sigbus;
  sigaction(SIGBUS,&sa,NULL);

  try
  {
    seg.open("st");
    RAMS::RPointer<char> lptr(1,&seg);
    char *p=lptr.ptr();
    char w = *p;
    cout << "Auf Offset " << lptr.offset() << ":" << w << endl;
    *p=(w=='\0' ? 'A' : w+1 );
    lptr+=4096;
    p=lptr.ptr();
    w = *p;
    cout << "Auf Offset " << lptr.offset() << ":" << w << endl;
    *p=(w=='\0' ? 'M' : w+1 );
  }
  catch(Systemerror &ex)
  {
    cerr << ex.what() << endl;
    exit(1);
  }
  if(crash) 
  {
    cerr << "Crashing bevor saveing ... " << endl;
    exit(1);
  }
  if(rollback)
  {
    cerr << "Rollback work ... " << endl;
    seg.rollback();
  }
  seg.close();
  return 0;
}
