#ifndef KVDUMPABLE_H
#define KVDUMPABLE_H
#include"RACE_Dumpable.h"
#include"logfilelayout.h"
#include"KVBaseTypes.h"
#include"gdat.h"
#include"LoggerSnapshotConnection.h"
#include"KVSemantik.h"

class KVDumpable : public RACE_Dumpable
{
public:
  KVDumpable(Gdat &key,Timestamp_t timestamp,Gdat &value);
  //##Documentation
  //## Constructor for the Read side
  KVDumpable(RACE::DataBlock *db,bool frag,RACE_LogfileOffset lo);
  Logfile::KVEntry *GetContent() { return (Logfile::KVEntry *)base(); }
  void GetKey(Gdat &key);
  void GetValue(Gdat &value);
  Timestamp_t GetTimestamp();
  void SetConnection(LoggerSnapshotConnection *lsc)
    {
      lsc_ = lsc;
    }
  virtual void InformOffset(RACE_LogfileOffset offset);
  virtual void Discard();
  void CallVisitor(RACE::DumpableVisitor *visitor);
protected:  
  RACE_Message_Block *CloneManagementData() const;
  KVDumpable(int)
    :RACE_Dumpable(),lsc_(0) {}
private:
  LoggerSnapshotConnection *lsc_;
};
#endif

