#ifndef KVSNAPSHOTDUMPABLE_H
#define KVSNAPSHOTDUMPABLE_H
#include"RACE_Dumpable.h"
#include"gdat.h"
#include"logfilelayout.h"
#include"LoggerSnapshotConnection.h"
#include"KVSemantik.h"
/*
 * Note: If the Entities have fixed length, the SnapshotDumpable
 *        would be a subclass of RACE_CollectionDumpable 
 *        In our example, we have variable size key fields. 
 */
class KVSnapshotDumpable : public RACE_Dumpable
{
public:
  KVSnapshotDumpable();
  KVSnapshotDumpable(RACE::DataBlock *db,bool frag,RACE_LogfileOffset lo);
  virtual void InformOffset(RACE_LogfileOffset offset);
  virtual void Discard();
  void CallVisitor(RACE::DumpableVisitor *visitor);
  //##Documentation
  //##Appends an new key - write site.
  //## Note: Here is not the check for uniqueness
  Logfile::KeyRecord *append(const Gdat& key);
  void SetLogSnapshotConnection(LoggerSnapshotConnection *lsc,time_t t) 
    { lsc_=lsc;
      snapshottime_=t;
    }
  //##Documentation
  //## readside - Build in Iterator
  //## Returns null if finisched
  Logfile::KeyRecord *first_key();
  //##Documentation
  //## readside - Build in Iterator
  //## Returns null if finisched
  Logfile::KeyRecord *next_key();
protected:
  RACE_Message_Block *CloneManagementData() const;
  //##Documentation
  //## Constructor for cloning - since we have a defaultconstructor
  //## we need here one with a dummy parameter
  KVSnapshotDumpable(char x);

private:
  size_t *length_ptr;
  time_t snapshottime_;
  LoggerSnapshotConnection *lsc_;
};
#endif

