#include"KVSnapshotSemantik.h"
#include"KVSnapshotDumpable.h"
#include<iostream>
#include<utility/envdebug.h>
static envdebug *debug = new envdebug("KVSnapshotSemantik");
const char *KVSnapshotSemantik::name()
{
  return "KVSnapshotSemantik";
}

void  KVSnapshotSemantik::KeyValue(KVDumpable *kvd)
{
  itersemantik_->KeyValue(kvd);
}

void  KVSnapshotSemantik::KeyValueSnapshot(KVSnapshotDumpable *kvsd)
{
  debug->print("KVSnapshotSemantik::handle KVSnapshotDumpable at %ld:%ld",
	       kvsd->GetOffset().part,kvsd->GetOffset().offset);
  for(Logfile::KeyRecord *cur_key = kvsd->first_key();
      cur_key!=NULL;cur_key=kvsd->next_key())
  {
     Gdat key(cur_key->key,cur_key->keylen);
     debug->print("%*s : %ld:%ld",key.get_len(),
		  (const char *)key.get_const_data(),
		  cur_key->offset.part,cur_key->offset.offset);
     try
     {
       RACE_Dumpable *dumpable;
       RACE::DataBlock *current;
       bool fragmented;
       RACE_LogfileOffset lo;
       hoc_.Add(cur_key->offset);
       if((current = reader_->ReadAt(cur_key->offset,fragmented,lo))!=NULL)
       {
	 dumpable=interp_->interpret(current,fragmented,lo);
	 dumpable->CallVisitor(itersemantik_);
	 dumpable->release();
       }
       else
       {
	 std::cerr << "Position not found " << std::endl;
       }
       //* Positioning at highest offset
       if((current = reader_->ReadAt(hoc_.GetValue(),fragmented,lo))!=NULL)
       {
	 dumpable=interp_->interpret(current,fragmented,lo);
	 //don't call semantic
	 dumpable->release();
       }
     }
     catch(RACE::ReadError& ex)
     {
       std::cerr << ex.what() << std::endl;
     }
  }
  std::cerr << "END" << std::endl;
}
