#ifndef TIME64_T
#define TIME64_T
#include<time.h>
#include"KVBaseTypes.h"
#include<utility/errorhandling.h>

Timestamp_t timespec2timestamp(const struct timespec &ts)
{
  return ((Timestamp_t)(ts.tv_sec)<<32 | (Timestamp_t)(ts.tv_nsec));
}

// http://www.frech.ch/man/man3/clock_gettime.3.html
Timestamp_t timestamp_now()
{
  struct timespec now;
  int r = clock_gettime(CLOCK_REALTIME,&now);
  RACE_COND_FAIL(r<0,"clock_gettime failed");
  return timespec2timestamp(now);
}
#endif 
