#include<time.h>
#include<iostream>
#include<utility/errorhandling.h>
#include"ActiveConsumer.h"
#include"RACE_LogfileReader.h"
#include"RACE_Interpreter.h"
#include"RACE_WaitingFullBufferHandling.h"

int main(int argc,char**argv)
{
  RACE::LogFileReader reader(new RACE::WaitingFullBufferHandling());
  RACE::Interpreter *interp = new RACE::Interpreter();
  ActiveConsumer *ac=new ActiveConsumer();
  ac->activate();
  RACE::DataBlock *current;
  RACE_Dumpable *dumpable;
  bool fragmented;
  RACE_LogfileOffset currentoffset;
  int retry=0;
  if(argc<2) { std::cerr << "Usage: " << argv[0] << " logfile " << std::endl; }
  reader.Open(argv[1]);
  do
  {
    try
    {
      while((current=reader.Read(fragmented,currentoffset))!=NULL)
      {
	dumpable=interp->interpret(current,fragmented,currentoffset);
	ac->DoWork(dumpable);
      }
    }
    catch(RACE::ReadError& ex)
    {
	std::cerr << "ReadError: " << ex.what() << std::endl;
    }
  } while(retry>0);
  reader.Close();
  ac->Cancel();
  ac->Release();
  ACE_Thread_Manager::instance()->wait();
  std::cerr << "done" << std::endl;
  return 0;
}
