#ifndef ERRORHANDLING_H
#define ERRORHANDLING_H
/****************************************************************
 * provides Macros for Abstraction over Errorhandling           *
 * aspect oriented programming ?                                *
 ****************************************************************/
#include "utility/errorclass.h"
#include "utility/output.h"
#include "utility/envdebug.h"

#define RACE_COND_FAIL(COND,MESSAGE...) output::cond_fail(COND,MESSAGE)
#define RACE_WARN(MESSAGE...)           output::warn(MESSAGE)
#define RACE_DEBUG(MESSAGE...)          output::debug(MESSAGE)
#define RACE_ERROR(MESSAGE...)          output::error(MESSAGE)
#define RACE_FATAL_ERROR(MESSAGE...)    output::fail(MESSAGE)
#define RACE_MEMORY_FAIL(COND_,FILE_,LINE_,FUNCTION_) \
         if(COND_) throw NoMoreDynamicMemory(FILE_,LINE_,FUNCTION_);
//Stolen from ACE
#include<ace/Synch_T.h>
#define RACE_GUARD_THROW_EX(MUTEX,OBJ,LOCK,EXCEPTION) \
  ACE_Guard< MUTEX > OBJ (LOCK); \
    if (OBJ.locked () == 0) throw (EXCEPTION);

#define RACE_GUARD(MUTEX,OBJ,LOCK,FILE_,LINE_,FUNCTION_) \
  ACE_Guard< MUTEX > OBJ (LOCK); \
    if (OBJ.locked () == 0) throw MutexFail(FILE_,LINE_,FUNCTION_);
#endif

